library IEEE;
use IEEE.std_logic_1164.all;

--  A testbench has no ports.
entity top_tb is
end top_tb;

architecture behav of top_tb is
  --  Declaration of the component that will be instantiated.
  component top
    port (
      sw_i : in STD_LOGIC_VECTOR (7 downto 0);
      led7_an_o : out STD_LOGIC_VECTOR (3 downto 0);
      led7_seg_o : out STD_LOGIC_VECTOR (7 downto 0)
    );
  end component;

  --  Specifies which entity is bound with the component.
  for top_0: top use entity work.top;
  signal sw_i : STD_LOGIC_VECTOR (7 downto 0);
  signal led7_an_o : STD_LOGIC_VECTOR (3 downto 0);
  signal led7_seg_o : STD_LOGIC_VECTOR (7 downto 0);
begin
  --  Component instantiation.
  top_0: top port map (sw_i => sw_i, led7_an_o => led7_an_o, led7_seg_o => led7_seg_o);

  --  This process does the real job.
  process
    type pattern_type is record
      --  The inputs of the top.
      sw_i : STD_LOGIC_VECTOR (7 downto 0);
      --  The expected outputs of the top.
      led7_an_o : STD_LOGIC_VECTOR (3 downto 0);
      led7_seg_o : STD_LOGIC_VECTOR (7 downto 0);
    end record;
    --  The patterns to apply.
    type pattern_array is array (natural range <>) of pattern_type;
    constant patterns : pattern_array :=
      (
        ("00000000", "1110", "01100001"),
        ("00000001", "1110", "00000011"),
        ("00000010", "1110", "00000011"),
        ("00000011", "1110", "01100001"),
        ("00000100", "1110", "00000011"),
        ("00000101", "1110", "01100001"),
        ("00000110", "1110", "01100001"),
        ("00000111", "1110", "00000011"),
        ("00001000", "1110", "00000011"),
        ("00001001", "1110", "01100001"),
        ("00001010", "1110", "01100001"),
        ("00001011", "1110", "00000011"),
        ("00001100", "1110", "01100001"),
        ("00001101", "1110", "00000011"),
        ("00001110", "1110", "00000011"),
        ("00001111", "1110", "01100001"),
        ("00010000", "1110", "00000011"),
        ("00010001", "1110", "01100001"),
        ("00010010", "1110", "01100001"),
        ("00010011", "1110", "00000011"),
        ("00010100", "1110", "01100001"),
        ("00010101", "1110", "00000011"),
        ("00010110", "1110", "00000011"),
        ("00010111", "1110", "01100001"),
        ("00011000", "1110", "01100001"),
        ("00011001", "1110", "00000011"),
        ("00011010", "1110", "00000011"),
        ("00011011", "1110", "01100001"),
        ("00011100", "1110", "00000011"),
        ("00011101", "1110", "01100001"),
        ("00011110", "1110", "01100001"),
        ("00011111", "1110", "00000011"),
        ("00100000", "1110", "00000011"),
        ("00100001", "1110", "01100001"),
        ("00100010", "1110", "01100001"),
        ("00100011", "1110", "00000011"),
        ("00100100", "1110", "01100001"),
        ("00100101", "1110", "00000011"),
        ("00100110", "1110", "00000011"),
        ("00100111", "1110", "01100001"),
        ("00101000", "1110", "01100001"),
        ("00101001", "1110", "00000011"),
        ("00101010", "1110", "00000011"),
        ("00101011", "1110", "01100001"),
        ("00101100", "1110", "00000011"),
        ("00101101", "1110", "01100001"),
        ("00101110", "1110", "01100001"),
        ("00101111", "1110", "00000011"),
        ("00110000", "1110", "01100001"),
        ("00110001", "1110", "00000011"),
        ("00110010", "1110", "00000011"),
        ("00110011", "1110", "01100001"),
        ("00110100", "1110", "00000011"),
        ("00110101", "1110", "01100001"),
        ("00110110", "1110", "01100001"),
        ("00110111", "1110", "00000011"),
        ("00111000", "1110", "00000011"),
        ("00111001", "1110", "01100001"),
        ("00111010", "1110", "01100001"),
        ("00111011", "1110", "00000011"),
        ("00111100", "1110", "01100001"),
        ("00111101", "1110", "00000011"),
        ("00111110", "1110", "00000011"),
        ("00111111", "1110", "01100001"),
        ("01000000", "1110", "00000011"),
        ("01000001", "1110", "01100001"),
        ("01000010", "1110", "01100001"),
        ("01000011", "1110", "00000011"),
        ("01000100", "1110", "01100001"),
        ("01000101", "1110", "00000011"),
        ("01000110", "1110", "00000011"),
        ("01000111", "1110", "01100001"),
        ("01001000", "1110", "01100001"),
        ("01001001", "1110", "00000011"),
        ("01001010", "1110", "00000011"),
        ("01001011", "1110", "01100001"),
        ("01001100", "1110", "00000011"),
        ("01001101", "1110", "01100001"),
        ("01001110", "1110", "01100001"),
        ("01001111", "1110", "00000011"),
        ("01010000", "1110", "01100001"),
        ("01010001", "1110", "00000011"),
        ("01010010", "1110", "00000011"),
        ("01010011", "1110", "01100001"),
        ("01010100", "1110", "00000011"),
        ("01010101", "1110", "01100001"),
        ("01010110", "1110", "01100001"),
        ("01010111", "1110", "00000011"),
        ("01011000", "1110", "00000011"),
        ("01011001", "1110", "01100001"),
        ("01011010", "1110", "01100001"),
        ("01011011", "1110", "00000011"),
        ("01011100", "1110", "01100001"),
        ("01011101", "1110", "00000011"),
        ("01011110", "1110", "00000011"),
        ("01011111", "1110", "01100001"),
        ("01100000", "1110", "01100001"),
        ("01100001", "1110", "00000011"),
        ("01100010", "1110", "00000011"),
        ("01100011", "1110", "01100001"),
        ("01100100", "1110", "00000011"),
        ("01100101", "1110", "01100001"),
        ("01100110", "1110", "01100001"),
        ("01100111", "1110", "00000011"),
        ("01101000", "1110", "00000011"),
        ("01101001", "1110", "01100001"),
        ("01101010", "1110", "01100001"),
        ("01101011", "1110", "00000011"),
        ("01101100", "1110", "01100001"),
        ("01101101", "1110", "00000011"),
        ("01101110", "1110", "00000011"),
        ("01101111", "1110", "01100001"),
        ("01110000", "1110", "00000011"),
        ("01110001", "1110", "01100001"),
        ("01110010", "1110", "01100001"),
        ("01110011", "1110", "00000011"),
        ("01110100", "1110", "01100001"),
        ("01110101", "1110", "00000011"),
        ("01110110", "1110", "00000011"),
        ("01110111", "1110", "01100001"),
        ("01111000", "1110", "01100001"),
        ("01111001", "1110", "00000011"),
        ("01111010", "1110", "00000011"),
        ("01111011", "1110", "01100001"),
        ("01111100", "1110", "00000011"),
        ("01111101", "1110", "01100001"),
        ("01111110", "1110", "01100001"),
        ("01111111", "1110", "00000011"),
        ("10000000", "1110", "00000011"),
        ("10000001", "1110", "01100001"),
        ("10000010", "1110", "01100001"),
        ("10000011", "1110", "00000011"),
        ("10000100", "1110", "01100001"),
        ("10000101", "1110", "00000011"),
        ("10000110", "1110", "00000011"),
        ("10000111", "1110", "01100001"),
        ("10001000", "1110", "01100001"),
        ("10001001", "1110", "00000011"),
        ("10001010", "1110", "00000011"),
        ("10001011", "1110", "01100001"),
        ("10001100", "1110", "00000011"),
        ("10001101", "1110", "01100001"),
        ("10001110", "1110", "01100001"),
        ("10001111", "1110", "00000011"),
        ("10010000", "1110", "01100001"),
        ("10010001", "1110", "00000011"),
        ("10010010", "1110", "00000011"),
        ("10010011", "1110", "01100001"),
        ("10010100", "1110", "00000011"),
        ("10010101", "1110", "01100001"),
        ("10010110", "1110", "01100001"),
        ("10010111", "1110", "00000011"),
        ("10011000", "1110", "00000011"),
        ("10011001", "1110", "01100001"),
        ("10011010", "1110", "01100001"),
        ("10011011", "1110", "00000011"),
        ("10011100", "1110", "01100001"),
        ("10011101", "1110", "00000011"),
        ("10011110", "1110", "00000011"),
        ("10011111", "1110", "01100001"),
        ("10100000", "1110", "01100001"),
        ("10100001", "1110", "00000011"),
        ("10100010", "1110", "00000011"),
        ("10100011", "1110", "01100001"),
        ("10100100", "1110", "00000011"),
        ("10100101", "1110", "01100001"),
        ("10100110", "1110", "01100001"),
        ("10100111", "1110", "00000011"),
        ("10101000", "1110", "00000011"),
        ("10101001", "1110", "01100001"),
        ("10101010", "1110", "01100001"),
        ("10101011", "1110", "00000011"),
        ("10101100", "1110", "01100001"),
        ("10101101", "1110", "00000011"),
        ("10101110", "1110", "00000011"),
        ("10101111", "1110", "01100001"),
        ("10110000", "1110", "00000011"),
        ("10110001", "1110", "01100001"),
        ("10110010", "1110", "01100001"),
        ("10110011", "1110", "00000011"),
        ("10110100", "1110", "01100001"),
        ("10110101", "1110", "00000011"),
        ("10110110", "1110", "00000011"),
        ("10110111", "1110", "01100001"),
        ("10111000", "1110", "01100001"),
        ("10111001", "1110", "00000011"),
        ("10111010", "1110", "00000011"),
        ("10111011", "1110", "01100001"),
        ("10111100", "1110", "00000011"),
        ("10111101", "1110", "01100001"),
        ("10111110", "1110", "01100001"),
        ("10111111", "1110", "00000011"),
        ("11000000", "1110", "01100001"),
        ("11000001", "1110", "00000011"),
        ("11000010", "1110", "00000011"),
        ("11000011", "1110", "01100001"),
        ("11000100", "1110", "00000011"),
        ("11000101", "1110", "01100001"),
        ("11000110", "1110", "01100001"),
        ("11000111", "1110", "00000011"),
        ("11001000", "1110", "00000011"),
        ("11001001", "1110", "01100001"),
        ("11001010", "1110", "01100001"),
        ("11001011", "1110", "00000011"),
        ("11001100", "1110", "01100001"),
        ("11001101", "1110", "00000011"),
        ("11001110", "1110", "00000011"),
        ("11001111", "1110", "01100001"),
        ("11010000", "1110", "00000011"),
        ("11010001", "1110", "01100001"),
        ("11010010", "1110", "01100001"),
        ("11010011", "1110", "00000011"),
        ("11010100", "1110", "01100001"),
        ("11010101", "1110", "00000011"),
        ("11010110", "1110", "00000011"),
        ("11010111", "1110", "01100001"),
        ("11011000", "1110", "01100001"),
        ("11011001", "1110", "00000011"),
        ("11011010", "1110", "00000011"),
        ("11011011", "1110", "01100001"),
        ("11011100", "1110", "00000011"),
        ("11011101", "1110", "01100001"),
        ("11011110", "1110", "01100001"),
        ("11011111", "1110", "00000011"),
        ("11100000", "1110", "00000011"),
        ("11100001", "1110", "01100001"),
        ("11100010", "1110", "01100001"),
        ("11100011", "1110", "00000011"),
        ("11100100", "1110", "01100001"),
        ("11100101", "1110", "00000011"),
        ("11100110", "1110", "00000011"),
        ("11100111", "1110", "01100001"),
        ("11101000", "1110", "01100001"),
        ("11101001", "1110", "00000011"),
        ("11101010", "1110", "00000011"),
        ("11101011", "1110", "01100001"),
        ("11101100", "1110", "00000011"),
        ("11101101", "1110", "01100001"),
        ("11101110", "1110", "01100001"),
        ("11101111", "1110", "00000011"),
        ("11110000", "1110", "01100001"),
        ("11110001", "1110", "00000011"),
        ("11110010", "1110", "00000011"),
        ("11110011", "1110", "01100001"),
        ("11110100", "1110", "00000011"),
        ("11110101", "1110", "01100001"),
        ("11110110", "1110", "01100001"),
        ("11110111", "1110", "00000011"),
        ("11111000", "1110", "00000011"),
        ("11111001", "1110", "01100001"),
        ("11111010", "1110", "01100001"),
        ("11111011", "1110", "00000011"),
        ("11111100", "1110", "01100001"),
        ("11111101", "1110", "00000011"),
        ("11111110", "1110", "00000011"),
        ("11111111", "1110", "01100001")
      );
  begin
    --  Check each pattern.
    for i in patterns'range loop
      --  Set the inputs.
      sw_i <= patterns(i).sw_i;
      --  Wait for the results.
      wait for 1 ns;
      --  Check the outputs.
      assert led7_an_o = patterns(i).led7_an_o
        report "bad an value" severity error;
      assert led7_seg_o = patterns(i).led7_seg_o
        report "bad seg value" severity error;
    end loop;
    assert false report "end of test" severity note;
    --  Wait forever; this will finish the simulation.
    wait;
  end process;

end behav;
